package org.jvnet.jaxbcommons.lang.builder;

import java.lang.reflect.Method;

public class CopyBuilder {

  public Object copy(Object object) {
    if (object == null) {
      return null;
    }
    else if (object instanceof String) {
      return object;
    }
    else if (object instanceof Number) {
      return object;
    }
    else if (object instanceof Cloneable) {
      try {
        final Method cloneMethod = object.getClass().getMethod("clone", (Class[]) null);
        if (cloneMethod.isAccessible()) {
          return cloneMethod.invoke(object, (Object[]) null);
        }
        else {
          return object;
        }
      }
      catch (Exception ex) {
        throw new UnsupportedOperationException("Unable to clone the object.");
      }
    }
    else {
      return object;
    }
  }

  public long copy(long value) {
    return value;
  }

  public int copy(int value) {
    return value;
  }

  public short copy(short value) {
    return value;
  }

  public char copy(char value) {
    return value;
  }

  public byte copy(byte value) {
    return value;
  }

  public double copy(double value) {
    return value;
  }

  public float copy(float value) {
    return value;
  }

  public boolean copy(boolean value) {
    return value;
  }

  public Object[] copy(Object[] array) {
    final Object[] copy = new Object[array.length];
    for (int index = 0; index < array.length; index++) {
      final Object element = array[index];
      final Object elementCopy = copy(element);
      copy[index] = elementCopy;
    }
    return copy;
  }

  public long[] copy(long[] array) {
    final long[] copy = new long[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public int[] copy(int[] array) {
    final int[] copy = new int[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public short[] copy(short[] array) {
    final short[] copy = new short[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public char[] copy(char[] array) {
    final char[] copy = new char[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public byte[] copy(byte[] array) {
    final byte[] copy = new byte[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public double[] copy(double[] array) {
    final double[] copy = new double[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public float[] copy(float[] array) {
    final float[] copy = new float[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

  public boolean[] copy(boolean[] array) {
    final boolean[] copy = new boolean[array.length];
    System.arraycopy(array, 0, copy, 0, array.length);
    return copy;
  }

}
