package org.jvnet.jaxbcommons.lang.builder;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.jvnet.jaxbcommons.lang.Cloneable;
import org.jvnet.jaxbcommons.lang.CopyTo;
import org.jvnet.jaxbcommons.lang.Copyable;

public class JAXBCopyBuilder extends CopyBuilder {

  public Object copy(Object object) {
    if (object == null)
      return null;
    else if (object instanceof List) {
      return copy((List) object);
    }
    else if (object instanceof Set) {
      return copy((Set) object);
    }
    else if (object instanceof CopyTo)
      return ((CopyTo) object).copyTo(null, this);
    else if (object instanceof Copyable)
      return ((Copyable) object).copyTo(null);
    else if (object instanceof Cloneable)
      return ((Cloneable) object).clone();
    else
      return super.copy(object);

  }

  public Object copy(List list) {
    final List copy = new ArrayList(list.size());
    for (Iterator iterator = list.iterator(); iterator.hasNext();) {
      final Object element = (Object) iterator.next();
      final Object copyElement = copy(element);
      copy.add(copyElement);
    }
    return copy;
  }

  public Object copy(Set set) {
    final Set copy = new HashSet(set.size());

    for (Iterator iterator = set.iterator(); iterator.hasNext();) {
      final Object element = (Object) iterator.next();
      final Object copyElement = copy(element);
      copy.add(copyElement);
    }
    return copy;
  }
}
